<template>
	<div>
        <v-container>
            <v-card v-if="campaign.id">
                
                <v-img v-bind:src="campaign.image" class="grey--text" height="300px">
                    <v-card-title class="fill-height align-end" v-text="campaign.title"></v-card-title>
                </v-img>

                <v-card-text>
                    <v-simple-table dense>
                        <tr>
                            <td><v-icon>mdi-home-city</v-icon> Alamat</td>
                            <td>{{campaign.address}}</td>
                        </tr>
                        <tr>
                            <td><v-icon>mdi-hand-heart</v-icon> Terkumpul</td>
                            <td class="blue--text align-right">Rp. {{campaign.required.toLocaleString('id-ID')}}</td>
                        </tr>
                        <tr>
                            <td><v-icon>mdi-cash</v-icon> Dibutuhkan</td>
                            <td class="red--text align-right">Rp. {{campaign.collected.toLocaleString('id-ID')}}</td>
                        </tr>
                    </v-simple-table>

                    Description 
                    <br>
                    {{campaign.description}}

                    <div class="pa-2">
                        <v-btn block color="primary" class="mb-1" v-on:click.prevent="makeDonation">
                            <v-icon left>mdi-transfer</v-icon>
                            Donate
                        </v-btn>					
				    </div>                    

                </v-card-text>

                <v-dialog
                        v-model="dialog"
                        persistent
                        max-width="300px"
                    >                    
                    <v-card>
                        <v-card-title>
                            <span class="headline">Tentukan Jumlah Donasi Anda</span>
                        </v-card-title>
                        <v-card-subtitle>
                            Donasi untuk :  {{campaign.title}}
                        </v-card-subtitle>
                        <v-card-text>
                            <v-text-field
                                        label="Jumlah Donasi"
                                        prefix="Rp"                                    
                                        required
                                        type="numeric"
                                        v-model="amount"
                            ></v-text-field>
                            <small>Donasi sebesar {{parseInt(amount).toLocaleString('id-ID')}}</small>
                                                                  
                        </v-card-text>
                            <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn
                                    color="green darken-1"                                    
                                    @click="submitDonation"
                                >
                                    Submit
                                </v-btn>
                                <v-btn
                                    color="yellow darken-1"                                    
                                    @click="dialog = false"
                                >
                                    Cancel
                                </v-btn>
                            </v-card-actions>                           
                    </v-card>
                </v-dialog>

                <alert/>

            </v-card>
        </v-container>
    </div>
</template>

<script>
import {mapActions} from 'vuex'
import alert from '../../components/Alert.vue'

export default {

    components:{
        alert
    },
	data:function(){
		return{
            title:'Data Campaign',
            dialog:false,
            amount:0,
            campaign:{}
        }
    },
    methods:{
        async getCampaign(id){
            try{
                let response = await axios.get(`/api/campaign/${id}/show`)
                if(response.status==200){
                    let {data} = response.data
                    this.campaign = data
                }
            }catch(e){
                console.log(e)
                let {response} = e.response

            }
        },
        makeDonation:function(){

            this.dialog=true
            
        },
        submitDonation:function(){            
            this.donate({
                amount:parseInt(this.amount),
                campaign:this.campaign
            })
            this.show({
                title:'success',
                message:`Donasi anda sebesar ${this.amount.toLocaleString('id-ID')} berhasil ditambahkan ke kotak donasi, klik pada kotak donasi untuk melanjutkan pembayaran!`
            })
            this.dialog=false
            this.campaign = {}
            this.amount = 0
            this.$router.push({name:'home'})
        },
        ...mapActions({
            donate:'donationTransaction/donate',
            show:'alert/show'
        }),        
        
    }
    ,mounted:function(){
        console.log('Campaign required')
        let {campaignId} = this.$router.currentRoute.params
        console.log(`Campaign param from ${campaignId}`)
        this.getCampaign(campaignId)
        
	}

}
</script>

<style>

</style>